- block:
  - include_role:
      name: commons
      tasks_from: helpers/volume.yaml
    vars:
      vol_name: "{{ ermg_name }}-ready-{{ errbit_tag }}-snap"
      vol_size: "{{ errbit_db_data_capacity }}"
  - name: Marks operation in progress
    set_fact:
      snap_failed: True
    when:
    - has_pvc is defined
    - has_pvc.resources is defined
    - (has_pvc.resources | length) > 0
  - name: Scales Errbit down to 0
    async: 30
    k8s:
      definition:
        apiVersion: "{{ deployment_apivers }}"
        kind: "{{ deployment_kind }}"
        metadata:
          name: "{{ errbit_name }}"
          namespace: "{{ namespace }}"
        spec:
          replicas: 0
    poll: 5
    when:
    - not (snap_failed | default(False))
  - include_role:
      name: commons
      tasks_from: snapshots/mongodb.yaml
    vars:
      db_data_capacity: "{{ errbit_db_data_capacity }}"
      db_host: "{{ ermg_name }}-ready"
      db_secret_name: "{{ ermg_name }}"
      job_assume_pod_netpol: "{{ errbit_name }}"
      provision_volume: False
      snap_mark: "{{ errbit_tag }}"
    when:
    - not (snap_failed | default(False))
  - name: Lookups MongoDB Snapshot Job
    async: 30
    changed_when: False
    k8s_info:
      api_version: batch/v1
      kind: Job
      namespace: "{{ namespace }}"
      name: "{{ ermg_name }}-ready-{{ errbit_tag }}-snap"
    no_log: True
    poll: 5
    register: mg_snap
    when:
    - not (snap_failed | default(False))
  - block:
    - name: Reverts Upgrade when snapshot failed
      async: 30
      k8s:
        definition:
          apiVersion: "{{ deployment_apivers }}"
          kind: "{{ deployment_kind }}"
          metadata:
            name: "{{ errbit_name }}"
            namespace: "{{ namespace }}"
          spec:
            replicas: "{{ errbit_replicas }}"
      poll: 5
    - name: Fails when snapshot failed
      fail:
        msg: "Failed upgrading Errbit to {{ errbit_tag }}"
    when:
    - >
        snap_failed | default(False)
        or (mg_snap is defined
            and mg_snap.resources is defined
            and (mg_snap.resources | length == 0
                or (mg_snap.resources[0].status is defined
                    and mg_snap.resources[0].status is defined
                    and (mg_snap.resources[0].status.completionTime is not defined
                         or (not ((mg_snap.resources[0].status.succeeded | default(0)) in [ 1, '1' ]))))))
  when:
  - do_backups
- block:
  - include_role:
      name: errbit
      tasks_from: db-upgrade.yaml
  - name: Checks Errbit Upgrade Status
    async: 30
    changed_when: False
    k8s_info:
      api_version: batch/v1
      kind: Job
      name: "{{ errbit_name }}-db-upgrade-{{ errbit_tag }}"
      namespace: "{{ namespace }}"
    no_log: True
    poll: 5
    register: db_job
  - block:
    - name: Scales Errbit back up
      async: 30
      k8s:
        definition:
          apiVersion: "{{ deployment_apivers }}"
          kind: "{{ deployment_kind }}"
          metadata:
            name: "{{ errbit_name }}"
            namespace: "{{ namespace }}"
          spec:
            replicas: "{{ errbit_replicas }}"
    - name: Fails when upgrade is still running
      fail:
        msg: "Failed upgrading Errbit database to {{ errbit_tag }}"
    when:
    - db_job is defined
    - db_job.resources is defined
    - db_job.resources | length > 0
    - db_job.resources[0].status is defined
    - not db_job.resources[0].status.succeeded is defined
  - include_role:
      name: commons
      tasks_from: helpers/deployment.yaml
    vars:
      cpu_limit: "{{ errbit_cpu_limit }}"
      cpu_request: "{{ errbit_cpu_request }}"
      dc_data: "{{ lookup('template', 'errbit.j2') }}"
      dc_name: "{{ errbit_name }}"
      dc_replicas: 1
      dc_tag: "{{ errbit_tag }}"
      memory_limit: "{{ errbit_memory_limit }}"
      memory_request: "{{ errbit_memory_request }}"
  - include_role:
      name: commons
      tasks_from: helpers/wait-for.yaml
    vars:
      check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                             kind=deployment_kind, namespace=namespace,
                             resource_name=errbit_name) | default('') }}"
      obj_name: "{{ errbit_name }}"
      retries_for: 60
      wait_for: 10
    when:
    - dc_started is defined
    - dc_started is changed
  - name: Checks Errbit Upgrade Status
    async: 30
    changed_when: False
    k8s_info:
      api_version: "{{ deployment_apivers }}"
      kind: "{{ deployment_kind }}"
      name: "{{ errbit_name }}"
      namespace: "{{ namespace }}"
    no_log: True
    poll: 5
    register: has_eb
  - block:
    - name: Fails when upgrade is still running
      fail:
        msg: "Failed upgrading Errbit to {{ errbit_tag }}"
      when:
      - has_eb.resources[0].status.readyReplicas == 0
    - include_role:
        name: commons
        tasks_from: helpers/deployment.yaml
      vars:
        cpu_limit: "{{ errbit_cpu_limit }}"
        cpu_request: "{{ errbit_cpu_request }}"
        dc_data: "{{ lookup('template', 'errbit.j2') }}"
        dc_name: "{{ errbit_name }}"
        dc_replicas: "{{ errbit_replicas }}"
        dc_tag: "{{ errbit_tag }}"
        memory_limit: "{{ errbit_memory_limit }}"
        memory_request: "{{ errbit_memory_request }}"
      when:
      - errbit_replicas not in [ '1', 1 ]
      - has_eb.resources[0].status.readyReplicas > 0
    when:
    - has_eb is defined
    - has_eb.resources is defined
    - has_eb.resources | length > 0
    - has_eb.resources[0].status is defined
    - has_eb.resources[0].status.readyReplicas is defined
  when:
  - not (snap_failed | default(False))
